﻿:Namespace arrayeditor ⍝ V1.06
⍝ Implements David Liebtag's array editor as UCMD
⍝ 2015 05 21 Adam: NS header
⍝ 2015 06 01 Adam: Help auto PW
⍝ 2015 11 12 Adam: moved help layout to framework
⍝ 2017 03 07 Adam: specific help per platform and ⎕ML
⍝ 2017 07 11 Becca: add an example
⍝ 2017 07 20 Adam: auto cmd name 

    ⎕IO←1 ⋄ ⎕ML←1
    ∇ d←DESC
      :If ⎕SE.SALTUtils.WIN
          :If 80=⎕DR''
              d←'Edit a simple or mixed array of enclosures using the Array Editor from davidliebtag.com'
          :Else
              d←'Edit a simple numeric array in a GUI editor'
          :EndIf
      :Else
          d←'Equivalent to )ED'
      :EndIf
    ∇

    ∇ r←List
      r←⎕NS ⍬
   ⍝ Name, group, short description and parsing rules
      r.(Name Group Desc Parse)←'Edit' 'Array'DESC'1'
    ∇

    ∇ r←level Help Cmd
      r←⊂DESC
      r,←'    arr←⍳2 3'('    ]',List.Group,'.',Cmd,' arr')
      :If ⎕SE.SALTUtils.WIN
      :AndIf 80=⎕DR''
      :AndIf 3≠#.⎕ML
          r,←⊂'NOTE: ⎕ML is always 3 in the array editor'
      :EndIf
    ∇

    ∇ r←Run(Cmd Input)
      0 ⎕SE.NumEd.numed⍨(⍕##.THIS){⍵,⍨(~∨/'#⎕'∊1↑⍵)/⍺,'.'}1⊃Input.Arguments
      r←0 0⍴0
    ∇


:EndNamespace ⍝ arrayeditor  $Revision: 30431 $ and ⎕ML
