﻿:Namespace Open ⍝ V1.05
⍝ Open a file under Windows
⍝ 2015 11 12 Adam: added version number
⍝ 2015 12 30 Adam: added Test
⍝ 2017 03 08 Adam: disable on non-Win
⍝ 2017 03 21 Adam: Try non-.Net
⍝ 2017 05 26 Adam: uppercase ]open→]Open, help overhaul

    ⎕IO←1 ⋄ ⎕ML←1

    If←/⍨

    ∇ r←List
      r←⎕NS ⍬
   ⍝ Name, group, short description and parsing rules
      r.(Name Group Desc Parse)←'Open' 'MSWin' 'Opens or explores external files or folders' '1SL -using='
      r/⍨←⎕SE.SALTUtils.WIN
    ∇

    ∇ r←Run(Cmd Input);name;⍙USING;ext;sel;⎕USING;fd;t;folder;isfile;path;Dext;SU;dir;cmd
      r←name←⊃t←Input.Arguments
     
      :If 0≢Input.using ⍝ Use .Net if we need to specify with what
      :OrIf 32<(⍎⎕NA'P shell32|ShellExecute* P P <0T P P I4')0 0 name 0 0 5 ⍝ Try non-.Net if we can
      :Else
     
          ⍙USING←Input.using
          ext←cmd←r←⍬
          SU←⎕SE.SALTUtils
     
          :If sel←0∊⍴t ⍝ ask the user if a file is not supplied
              ⎕USING←'System.Windows.Forms,System.Windows.Forms.dll'
              fd←⎕NEW OpenFileDialog
              →0 If'OK'≢⍕fd.ShowDialog ⍬
              name←fd.FileName
          :EndIf
          Dext←SU.SALTEXT
     ⍝ If this is a relative path we search in the list of SALT working directories
          :If SU.isRelPath path←name
              :For folder :In {⎕ML←3 ⋄ (⍵≠'∘')⊂⍵}⎕SE.UCMD'settings workdir'
                  isfile←~SU.isDir path←folder SU.ClassFolder name
                  ext←Dext If(⍙USING≡0)∧isfile∧sel⍱'.'∊name ⍝ add extension if none supplied
                  →run If 1=⍴dir←⎕IO⊃'a'SU.Dir path,ext
              :EndFor
              'File not found'⎕SIGNAL 922
          :Else
              :If ~dir←SU.isDir name
                  ext←Dext If(⍙USING≡0)∧sel⍱'.'∊name
              :EndIf
          :EndIf  ⍝ otherwise we use it directly
     run: r←dir RunCmd path,ext ⍝ full path name case
      :EndIf
    ∇

    ∇ r←level Help Cmd
      r←'To open the file "name" or explore the folder "name":'('    ]',Cmd,' name')''
      r,←'To open the file "name" with the program "app":'('    ]',Cmd,' name -using=app')
      ⍝r,←⊂'-permanent     remember the program to use in the future'
    ∇

    ∇ r←{dir}RunCmd path;⎕USING ⍝ this is only used by <Open>
      ⎕USING←'System.Diagnostics,system.dll'
      r←⍙USING{6::(⍺≡0)/⍵ ⋄ 90::⎕EXCEPTION.Message ⋄ ⍵⊣Process.Start(0≡⍺)↓⍺ ⍵}path
      r ⎕SIGNAL 922 If path≢r
    ∇

    :Section Test
    ∇ r←Test dummy;Pids;pids;pid
      Pids←{3::⍬ ⋄ 2 2∘⊃¨⎕VFI¨3↓⎕CMD'tasklist /FI "IMAGENAME eq notepad.exe"'}
      pids←Pids ⍬
      {}⎕SE.UCMD List.Name,' C:\Windows\System32\notepad.exe'
      r←1=⍴pid←pids~⍨Pids ⍬
      {}⎕CMD'taskkill /pid ',⍕pid
    ∇
    :EndSection

:EndNamespace
