﻿:namespace tohtml ⍝ V1.04
⍝ Produce an HTML version of APL objects
⍝ 2015 05 22 Adam: NS header
⍝ 2017 03 08 Adam: move to MSWIN and disable on non-Win
⍝ 2017 07 11 Stephanie: update help style
⍝ 2017 07 20 Adam: auto cmd name

    (⎕IO ⎕ML)←1

    ∇ r←List
      r←⎕NS ⍬
⍝ Name, group, short description and parsing rules
      r.Name←'ToHTML'
      r.Group←'MSWIN'
      r.Desc←'Produce an HTML version of APL objects'
      r.Parse←' -title=  -full  -filename=  -clipboard  -xref '
      r/⍨←⎕SE.SALTUtils.WIN
    ∇

    ∇ r←Run(Cmd Args)
      0 ## ⎕SE.SALT.Load'tools\Inet\HTMLdoc'
      r←Args ##.HTMLdoc.PrepareCodeForHtml Args.Arguments
    ∇

    ∇ r←lev Help Cmd;⎕ML;r
      ⎕ML←1
      r←⍬
      r,←⊂'Prepare some HTML text to display functions and namespaces in a browser.'
      r,←⊂'The -full modifier includes header and css info.'
      r,←⊂'The -filename modifier allows you to redirect output to a file.'
      r,←⊂'The -clipboard modifier redirects output to the clipboard.'
      r,←⊂'The -xref modifier produces a cross reference of names for each function.'
     
      :If ×lev
          r,←'' 'Example: produce an html file showing class Parser along with a cross reference in file \tmp\x.html'
          r,←⊂'      ]',Cmd,' ⎕se.Parser -file=\tmp\x.html -xref'
      :Else
          r,←''(']??',Cmd,'    ⍝ For an example')
      :EndIf
    ∇

:Endnamespace ⍝ tohtml  $Revision: 30431 $
